"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const guard_1 = require("./guard");
const vality_1 = require("./vality");
vality_1.vality.string = (0, guard_1.guard)("string", val => typeof val === "string", {
    minLength: (val, o) => val.length >= o,
    maxLength: (val, o) => val.length <= o,
    match: (val, o) => o.test(val),
});
// prettier-ignore
vality_1.vality.number = (0, guard_1.guard)("number", val => (typeof val === "number" && val > Number.MIN_SAFE_INTEGER && val < Number.MAX_SAFE_INTEGER), {
    min: (val, o) => val >= o,
    max: (val, o) => val <= o,
    integer: (val, o) => (val % 1 === 0 ? o : !o),
});
vality_1.vality.boolean = (0, guard_1.guard)("boolean", val => typeof val === "boolean");
vality_1.vality.literal = lit => (0, guard_1.guard)("literal", val => val === lit);
// TODO: Accept user defined relation checks (we already support types so right now, those are lying)
vality_1.vality.relation = () => (0, guard_1.guard)("relation", val => typeof val === "number" && val > 0 && val % 1 === 0);
